using System;

using Monocle;
using Celeste;
using Celeste.Mod;


namespace Bitsbolts {
  public class MainModule : EverestModule {
    public override Type SessionType => typeof(ModuleSession);
    public static ModuleSession Session => (ModuleSession) Instance._Session;
    public static MainModule Instance;

    public MainModule() { Instance = this; }

    public override void Load() {
      Attributes.DispatchAttr(typeof(OnLoad));
    }

    public override void LoadContent(bool firstLoad) {
      Attributes.DispatchAttr(typeof(OnLoadContent));
    }

    public override void Initialize() {
      Attributes.DispatchAttr(typeof(OnInitialize));
    }

    public override void Unload() {
      Attributes.DispatchAttr(typeof(OnUnload));
    }
  }
}
