using System;

using Microsoft.Xna.Framework;
using Monocle;
using Celeste;


namespace Bitsbolts.Components {
  [Tracked]
  public class FancyTextComponent : BoundedGraphicsComponent {
    public FancyText.Text Text;
    public bool JustifyPerLine;
    public Vector2 Justify;

    // todo: add more params in here...
    public FancyTextComponent(
      FancyText.Text text, Vector2 position, Vector2? justify = null, bool justifyPerLine = true
    ) : base(true) {
      this.Text = text;
      base.Position = position;
      base.Size = new Vector2(
        this.Text.CalcLinesWidth(),
        this.Text.CalcLinesHeight()
      );
      this.JustifyPerLine = justifyPerLine;

      this.Justify = justify ?? new Vector2(0.5f, 0.0f);  // center horz/top vert
      // todo: support using base.Color here? for the default text color maybe?
    }

    public override void Render() {
      if (this.JustifyPerLine) {
        this.Text.DrawJustifyPerLine(
          position: this.Position,
          justify: this.Justify,
          scale: base.Scale,
          alpha: 1f
        );
      } else {
        this.Text.Draw(
          position: this.Position,
          justify: this.Justify,
          scale: base.Scale,
          alpha: 1f
        );
      }
    }
  }
}
