using System;
using System.Linq;

using Microsoft.Xna.Framework;
using Monocle;
using MonoMod.Utils;
using Celeste;
using Celeste.Mod;
using Celeste.Mod.Entities;


namespace Bitsbolts.Components {
  // This class is effectively internal but Monocle [Tracked]
  [Tracked]
  public class PreventWallGrab : Component {
    [OnLoad]
    public static void Load() {
      On.Celeste.ClimbBlocker.Check_Scene_Entity += OnClimbBlockerCheck;
    }

    [OnUnload]
    public static void Unload() {
      On.Celeste.ClimbBlocker.Check_Scene_Entity -= OnClimbBlockerCheck;
    }


    internal PreventWallGrab() : base(false, false) {}

    // this also blocks climbjumping but eh doesn't matter for our usecase
    private static bool OnClimbBlockerCheck(
      On.Celeste.ClimbBlocker.orig_Check_Scene_Entity orig, Scene scene, Entity entity
    ) {
      if (entity.Get<PreventWallGrab>() != null) { return true; }

      return orig(scene, entity);
    }
  }
}
