using System;
using System.Linq;

using Microsoft.Xna.Framework;
using Monocle;
using MonoMod.Utils;
using Celeste;
using Celeste.Mod;
using Celeste.Mod.Entities;


namespace Bitsbolts.Components {
  // This class is effectively internal but Monocle [Tracked]
  [Tracked]
  public class PreventWallJump : Component {
    [OnLoad]
    public static void Load() {
      On.Celeste.Player.WallJump += OnPlayerWallJump;
      On.Celeste.Player.WallJumpCheck += OnPlayerWallJumpCheck;
    }

    [OnUnload]
    public static void Unload() {
      On.Celeste.Player.WallJump -= OnPlayerWallJump;
      On.Celeste.Player.WallJumpCheck -= OnPlayerWallJumpCheck;
    }


    internal PreventWallJump() : base(false, false) {}

    private static void OnPlayerWallJump(On.Celeste.Player.orig_WallJump orig, Player self, int direction) {
      if (self.Get<PreventWallJump>() != null) { return; }

      orig(self, direction);
    }

    private static bool OnPlayerWallJumpCheck(On.Celeste.Player.orig_WallJumpCheck orig, Player self, int direction) {
      if (self.Get<PreventWallJump>() != null) { return false; }

      return orig(self, direction);
    }
  }
}
