using System;
using System.Linq;
using System.Collections.Generic;

using Microsoft.Xna.Framework;
using Monocle;
using MonoMod.RuntimeDetour;
using MonoMod.Utils;
using Celeste;
using Celeste.Mod;
using Celeste.Mod.Entities;

using Bitsbolts.Entities;
using Bitsbolts.Components;


namespace Bitsbolts.Examples {
  [CustomEvent("Bitsbolts/CreditsCutscene")]
  internal class CreditsCutscene : CutsceneEntity {
    public CreditsScroller Scroller;
    public override void OnBegin(Level level) {
      level.Add(this.Scroller = new CreditsScroller());

      this.Scroller.Add(new FancyTextComponent(
        FancyText.Parse(
          text: "bitsbolts_creditsdemo".DialogNlOrKey(),
          maxLineWidth: (int) this.Scroller.Width,
          linesPerPage: 400
        ),
        new Vector2(this.Scroller.Width * .5f, 0f)
      ));

      Player player = level.Tracker.GetEntity<Player>();
      player.StateMachine.State = 11;
      player.StateMachine.Locked = true;
    }

    public override void OnEnd(Level level) {
      this.Scroller.RemoveSelf();
      Player player = level.Tracker.GetEntity<Player>();
      player.StateMachine.Locked = false;
      player.StateMachine.State = 0;

      if (this.WasSkipped) {
      }
    }
  }
}
