using System;

using Microsoft.Xna.Framework;
using Monocle;

namespace Bitsbolts {
  public class BoundedGraphicsComponent: GraphicsComponent {
    public Vector2 Size { get; set; }

    public float Height {
      get => this.Size.Y;
      set { this.Size = new Vector2(this.Size.X, value); }
    }
    public float Width {
      get => this.Size.X;
      set { this.Size = new Vector2(value, this.Size.Y); }
    }
    public Vector2 Center {
      get => this.Position + this.Size / 2;
      private set {}
    }

    public Hitbox Hitbox {
      get => new Hitbox(this.Width, this.Height, this.Position.X, this.Position.Y);
    }

    public BoundedGraphicsComponent(bool active) : this(Vector2.Zero, Vector2.Zero, active) {}

    public BoundedGraphicsComponent(Vector2 position, Vector2 size, bool active) : base(active) {
      this.Position = position;
      this.Size = size;
    }
  }
}
