using System;
using System.Collections;
using System.Reflection;
using System.Runtime.ExceptionServices;

using Microsoft.Xna.Framework;
using Monocle;
using Celeste;


namespace Bitsbolts {
  internal class CardedException : Exception {
    internal CardedException() {}
    internal CardedException(string message) : base(message) {}
    // internal CardedException(string message, Exception inner) : base(message, inner) {}
    internal CardedException(Exception inner) : base(inner.Message, inner) {}

    internal string ToShortString() {
      if (this.InnerException != null) {
        return $"{base.InnerException.GetType().Name}: {base.InnerException.ToString()}";
      } else {
        return this.Message;
      }
    }

    internal Exception ToException() {
      if (this.InnerException != null) {
        return this.InnerException;
      }
      return new Exception(this.Message);
    }
  }

  internal static class OopsieExt {
    internal static CardedException Carded(this Exception ex) {
      return new CardedException(ex);
    }
  }
}
