using System;
using System.Linq;
using System.Collections.Generic;


namespace Bitsbolts {
  internal static class Collections {
    internal static IEnumerable<T> CountingSort<T,K>(
      IEnumerable<T> input, Func<T, K> key_func
    ) {
      var counted = new SortedDictionary<K, List<T>>();
      foreach (T item in input) {
        var key = key_func(item);
        if (!counted.ContainsKey(key)) {
          var list = new List<T>();
          list.Add(item);
          counted.Add(key, list);
        } else {
          counted[key].Add(item);
        }
      }

      IEnumerable<T> output = Enumerable.Empty<T>();
      foreach (var slice in counted.Values) {
        output = output.Concat(slice);
      }
      return output;
    }
  }
}
