using System;

using Microsoft.Xna.Framework;
using Monocle;
using Celeste;
using Celeste.Mod;
using Celeste.Mod.Entities;

using Bitsbolts.Components;
using Bitsbolts.Entities;


namespace Bitsbolts.Triggers {
  [CustomEntity("Bitsbolts/GrablessBerryCollect")]
  public class GrablessBerryCollect : Trigger {
    public GrablessBerryCollect(EntityData data, Vector2 offset) : base(data, offset) {
      var flags = data.Attr("flags", "").ParseFlagstrs();
      if (flags.Count > 0) { base.Add(new FlagstrTrigger(flags)); }
    }

    public override void OnEnter(Player player) {
      foreach (var follower in player.Leader.Followers) {
        if (follower.Entity is GrablessBerry berry) {
          berry.QueueCollect();
        }
      }
    }
  }
}
