using System;
using System.Collections.Generic;
using System.Linq;

using Microsoft.Xna.Framework;
using Monocle;
using Celeste;
using Celeste.Mod.Entities;

using Bitsbolts.Components;


namespace Bitsbolts.Triggers {
  [CustomEntity("Bitsbolts/RemoveEntities")]
  public class RemoveEntities : Trigger {
    public readonly bool AllowUndo;
    public List<EntityID> Eids;

    public RemoveEntities(EntityData data, Vector2 offset) : base(data, offset) {
      this.Eids = data.Attr("eids", "").ParseEIDs();

      var flags = data.Attr("flags", "").ParseFlagstrs();
      if (flags.Count > 0) { base.Add(new FlagstrTrigger(flags)); }
      this.AllowUndo = data.Bool("allowUndo", false);
    }

    public override void OnStay(Player player) {
      base.OnStay(player);

      // todo: fix this shit to allow removing entities from donotload
      (this.Scene as Level).Session.DoNotLoad.UnionWith(this.Eids);

      // (this.Scene as Level).Session.DoNotLoad.ExceptWith(this.Eids);
    }
  }
}
