using System;

using Microsoft.Xna.Framework;
using Monocle;
using MonoMod.Utils;
using Celeste;
using Celeste.Mod;
using Celeste.Mod.Entities;

using Bitsbolts.Components;
using Flagstrs = System.Collections.Generic.Dictionary<string, bool>;


namespace Bitsbolts.Triggers {
  [Tracked]
  [CustomEntity("Bitsbolts/StrawberryAllowfield")]
  public class StrawberryAllowfield : Trigger {
    [OnLoad]
    public static void Load() {
      On.Celeste.Player.Update += OnPlayerUpdate;
    }

    [OnUnload]
    public static void Unload() {
      On.Celeste.Player.Update -= OnPlayerUpdate;
    }

    public StrawberryAllowfield(EntityData data, Vector2 offset) : base(data, offset) {
      var flags = data.Attr("flags").ParseFlagstrs();
      if (flags.Count > 0) { base.Add(new FlagstrTrigger(flags)); }
    }

    private static void OnPlayerUpdate(On.Celeste.Player.orig_Update orig, Player player) {
      orig(player);

      var dd = DynamicData.For(player);
      if (dd.Get<bool>("onGround") && player.CollideCheck<StrawberryAllowfield>()) {
        dd.Set("OnSafeGround", true);
      }
    }
  }
}
