using System;
using System.Linq;
using System.Collections.Generic;

using Microsoft.Xna.Framework;
using Monocle;
using MonoMod.Utils;
using Celeste;
using Celeste.Mod;
using Celeste.Mod.Entities;

using Bitsbolts.Components;
using Flagstrs = System.Collections.Generic.Dictionary<string, bool>;
using UnboundedDashingComponent = Bitsbolts.Components.UnboundedDashing;


namespace Bitsbolts.Triggers {
  [CustomEntity("Bitsbolts/UnboundedDashing")]
  public class UnboundedDashing : Trigger {
    private UnboundedDashingComponent component;
    public UnboundedDashing(EntityData data, Vector2 offset) : base(data, offset) {
      var flags = data.Attr("flags", "").ParseFlagstrs();
      if (flags.Count > 0) { base.Add(new FlagstrTrigger(flags)); }
    }

    public override void OnEnter(Player player) {
      base.OnEnter(player);

      if (component == null) {
        player.Add(component = new UnboundedDashingComponent());
      }
    }

    public override void OnLeave(Player player) {
      base.OnLeave(player);

      if (component != null) {
        component.RemoveSelf();
        component = null;
      }
    }
  }
}
