# bits & bolts documentation
> he would never write documentation wtf

Fucking read tooltips people! Every field has a tooltip with some helpful information on what it does or what format it expects. Also see [Formats](#formats) for important documentation on how flags work in this mod!

- [bits \& bolts documentation](#bits--bolts-documentation)
  - [Formats](#formats)
    - [Flagstrings](#flagstrings)
    - [Fancy Text](#fancy-text)
  - [Entities](#entities)
    - [Global Room Loader Controller](#global-room-loader-controller)
    - [Grabless Berry](#grabless-berry)
    - [Loader Respawn](#loader-respawn)
    - [Mostly Temporary Key](#mostly-temporary-key)
    - [Save Data Flag Sync Controller](#save-data-flag-sync-controller)
    - [Sturdy Dash Block](#sturdy-dash-block)
  - [Triggers](#triggers)
    - [Block Screen Transitions](#block-screen-transitions)
    - [Flags](#flags)
    - [Flag Lookout Blocker](#flag-lookout-blocker)
    - [Flag Zone](#flag-zone)
    - [Grabless Berry Collect](#grabless-berry-collect)
    - [No Retry](#no-retry)
    - [Redirect Motion](#redirect-motion)
    - [Resize Triggers](#resize-triggers)
    - [Skip Badeline Boost](#skip-badeline-boost)
    - [Strawberry Allowfield](#strawberry-allowfield)
  - [Commands](#commands)


## Formats

### Flagstrings
All flag options for this mod supports *flagstrings*, a way to invert and encode multiple flags.
Use `!flag` to check/set the inverse of a flag, and separate multiple flags with commas: `flag1,!flag2,flag3`.

If flags are being checked, all provided flags need to match and be the correct value.
If flags are being set, all flags are set to the given value.
If flags are being unset, all flags are set to the inverted value.

### Fancy Text
Works anywhere fancy text is used in game. This includes the usual things like dialog textboxes, but sometimes some estoric things like menu entries:
- `{^ 1.5}` sets the text size to 150% of normal size. `1.0` is normal size.
- `{/^}` resets the text size to normal


## Entities

### Global Room Loader Controller
This controller that configures how entities and triggers from global rooms are loaded.

In general, this mod recognizes any room whose name *starts with* `_bb_global` as a *global room*. By default, entities or triggers that are placed in a global room will be automatically loaded on every room in the whole map, even if there's not this controller in it. Keep in mind that the position of entities and triggers is not deterministic due to awful loading quirks. So, if you are placing down positionally-activated triggers, consider using a [resize trigger trigger](#resize-triggers) to resize the triggers to the screen or map size.

To configure how a specific global room is loaded, place a global room loader controller in the global room. Then, the global room will only be loaded if the controller's flags/room list matches (if fields are present).

Note: after creating a room starting with `_bb_global`, since Lönn will consider the global room as the first room, you may need to change your map's default starting room in map metadata to your map's actual starting room.

### Grabless Berry
A persistent challenge berry which disables grabbing, walljumping, and/or climbjumping (configurable). The berry survives deaths and reloads. Use either the golden berry collect trigger, or the special [Grabless Berry Collect Trigger](#grabless-berry-collect) to trigger collection. Similar to goldens, will collect when the player collects a crystal heart at the end of a B/C-side, or when "End Level on Heart" is checked.

### Loader Respawn
todo: write this ig

### Mostly Temporary Key
A key which largely acts like the Temporary Key from Frost Helper, but doesn't respawn after use, is intended to be used on normal key doors, and survives screen transitions. It disappears from the player and respawns at the key's spawnpoint when the player dies. If it was used to unlock a door, it will never respawn again for the current session.

### Save Data Flag Sync Controller
A controller which synchronizes flags and loads/saves them to the savefile. This adds persistence to flags allowing them to be saved and loaded even between map restarts. Any changes to the flags will be saved whenever the game is next saved. It is safe have multiple identical flag controllers spread across different rooms.

Flags are stored as vanilla savedata flags prefixed with the map SID like so: `yourmod/yourmap:flag`, unless "Raw" is checked in which case flags are stored into savedata as is. Using raw mode can cause flag conflicts between maps, and you should always manually prefix all flags to avoid conflicts.

### Sturdy Dash Block
A dash block which is sturdy enough to stop kevins/melvins when colliding. Otherwise acts identically to a dash block.


## Triggers

### Block Screen Transitions
Blocks screen transitions when the player is inside the trigger. Can be flag toggled.

Placing upwards or downwards blocking triggers requires 2 tiles of extra padding beyond the room border to account for the lower deathplane and ceiling headroom. Using a [resize trigger trigger](#resize-triggers) on this to resize it to room size will correctly account for this extra padding.

### Flags
A flag trigger that supports setting multiple flags at a time using flagstrings. Also supports setting flags on room load (trigger added) or room unload (trigger removal).

### Flag Lookout Blocker
A flag toggled lookout blocker.

### Flag Zone
A flag trigger which has the end effect of setting flags whenever the player is in the trigger. If the player leaves the trigger the flags are unset. Optionally flags can also be unset on level load, making the state of the flags solely controlled by if the player is in the trigger.

### Grabless Berry Collect
Immediately collects all grabless berries (irrespective of the berry options). Can be flag toggled.

### No Retry
Disables the retry option from the pause menu. Can be flag toggled.

### Redirect Motion
Redirects player motion to a specific direction on entering the trigger. Can be flag toggled. Works well with dream blocks, teleport triggers, boosters, etc.

### Resize Triggers
[View entity "documentation"](https://files.catbox.moe/svd8ua.mp4)

### Skip Badeline Boost
Advances to the specified node in the selected badeline boost entity. If there are multiple boost entities in the level, create a new node and place it close to the desired entity. Does not advance to previous nodes unless backwards is selected. Works well for mid-room player spawnpoints if instant is selected. Works with some modded badeline boost entities.

<!-- ### Skip Fling Bird (WIP)
Literally the same thing as the [Skip Badeline Boost Trigger](#skip-badeline-boost) but for the Fling Bird. -->

### Strawberry Allowfield
The opposite of the Strawberry Blockfield Entity. Considers whatever ground the player is standing on as "safe ground" and allows collection of berries, irrespective of the type of ground. Allows berry collection when standing on the following entities:
- Cassette blocks
- Crumble blocks
- Glass blocks
- Ice/boost/core blocks
- Intro crushers
- Key doors
- Move blocks
- Swap blocks
- Switch gates
- Zipper blocks
- All variants of trigger spikes
- Probably some more solids that I forgot about
- Probably all modded entities that mark unsafe ground too who knows

<!-- currently wip: RemoveEntities, TagEntities, RespawnEntities -->


## Commands
- `bb_flag` Lists all session flags. This is the *normal* type of flag that you'll use in maps.
- `bb_flag [flag]` Gets the session flag named `flag`.
- `bb_flag [flag] [0/1/true/false]` Sets or unsets the flag `flag`.
- `bb_levelflag` Lists all level flags.
- `bb_levelflag [flag]` Gets the level flag named `flag`.
- `bb_levelflag [flag] [0/1/true/false]` Sets or unsets the level flag `flag`.
- `bb_saveflag` Lists all save data flags.
- `bb_saveflag [flag]` Gets the save data flag named `flag`.
- `bb_saveflag [flag] [0/1/true/false]` Sets or unsets the save data flag `flag`. Careful, this may affect other maps on the same savefile!
- `bb_dnlflag` Lists all do not load flags.
- `bb_dnlflag [level:id]` Gets the do not load flag named `level:id`.
- `bb_dnlflag [level:id] [0/1/true/false]` Sets or unsets the do not load flag `level:id`.
- `bb_entityflag` Lists all session entity flags.
- `bb_entityflag [level:id]` Gets the session entity flag named `level:id`.
- `bb_entityflag [level:id] [0/false]` Removes the session entity flag `level:id`.
- `bb_give_jelly` Spawns in an immortal jellyfish
- `bb_ent [entityname]` Spawns in an entity from any mod by it's entity name, as it shows in the Lönn entity options titlebar (e.g. `bb_ent glider` for vanilla jellys, or `bb_ent DreamJellyfish` for CommunalHelper dream jellys). Careful, some complex entities may crash the game :(
- `bb_giveglb` Gives the player a grabless berry
- `bb_giveglbjump` Gives the player a grabless berry with no walljumping
