local rectangle = require("structs.rectangle")

local exports = {
  name = "Bitsbolts/LoaderRespawn",
  placements = {
    {
      name = "areastart",
      data = {
        onAreaStart = true,
        onSessionResume = false,
        onGoldenRestart = false,
        saveRespawnPoint = true,
        global = false,
        taintSession = false,
      }
    },
    {
      name = "areastart_global",
      data = {
        onAreaStart = true,
        onSessionResume = false,
        onGoldenRestart = false,
        saveRespawnPoint = true,
        global = true,
        taintSession = false,
      }
    },
    {
      name = "sessionresume",
      data = {
        onAreaStart = false,
        onSessionResume = true,
        onGoldenRestart = false,
        saveRespawnPoint = true,
        global = false,
        taintSession = false,
      }
    },
    {
      name = "goldenrestart_global",
      data = {
        onAreaStart = false,
        onSessionResume = false,
        onGoldenRestart = true,
        saveRespawnPoint = true,
        global = true,
        taintSession = true,
      }
    }
  },
  justification = { 8/13, 1 },
  -- offset = { 8, 17 },
}

function exports.texture(room, entity)
  if entity.onAreaStart then
    return "bitsbolts/loenn/loader_respawn_areastart"
  elseif entity.onGoldenRestart then
    return "bitsbolts/loenn/loader_respawn_goldenrestart"
  else
    return "bitsbolts/loenn/loader_respawn_sessionresume"
  end
end

-- function exports.rectangle(room, entity, viewport)
--   return rectangle.create(
--     (entity.x or 0) + (entity.offset.x or 8),
--     (entity.y or 0) + (entity.offset.y or 17),
--     32,
--     32
--   )
-- end

return exports
