local drawableRect = require("structs.drawable_rectangle")

local exports = {
  name = "Bitsbolts/ResizeTriggers",
  placements = {
    {
      name = "screen",
      data = {
        mode = "screen"
      }
    },
    {
      name = "this",
      data = {
        mode = "this"
      }
    },
    {
      name = "area",
      data = {
        mode = "area",
        nodes = {{}, {}}
      }
    },
    {
      name = "map",
      data = {
        mode = "map"
      }
    },
  },
  nodeLimits = function (room, trigger)
    if trigger.mode ~= nil and trigger.mode == "area"
    then return 2, 2 else return 0, 0 end
  end,
  -- fixme: nodeVisibility is buggy and doesn't work as expected wtf?
  -- nodeVisibility = function (trigger)
  --   if trigger.mode ~= nil and trigger.mode == "area"
  --   then return "always" else return "never" end
  -- end,
  nodeLineRenderType = false,
  fieldInformation = {
    mode = {
      options = {
        { "cover screen", "screen" },
        { "cover this trigger", "this" },
        { "cover specified node area", "area" },
        { "cover entire map", "map" },
      },
      editable = false
    }
  }
}

local borderColor = {1.0, 1.0, 1.0, 1.0}

-- function exports.sprite(room, trigger, viewport)
--   if trigger.mode == "area" then
--     if trigger.nodes ~= nil and #trigger.nodes == 2 then
--       return {
--         drawableRect.fromRectangle(
--           "line",
--           trigger.nodes[1].x,
--           trigger.nodes[1].y,
--           trigger.nodes[2].x - trigger.nodes[1].x,
--           trigger.nodes[2].y - trigger.nodes[1].y,
--           borderColor
--         )
--       }
--     end
--   end
-- end

return exports
